#include "stlocal.h"
#pragma hdrstop

// copyright (c) 1992 by Paul Wheaton

static Bool DigitToken(char C)
  {
    return ((C=='@') || (C=='#'));
  }

static void FindDigitToken(String &S, int &I)
  {
    while (!DigitToken(S[I])) I++;
  }

static void DoFillers(String &Mask, int Fillers)
  {
    int I=0;
    while (Fillers)
      {
        FindDigitToken(Mask,I);
        if (Mask[I]=='@') Mask[I]='0';
        else Mask[I]=' ';
        Fillers--;
      }
  }

static void DoSpaceFillers(String &Mask, int Fillers)
  {
    int I=0;
    FindDigitToken(Mask,I);
    while (Fillers)
      {
        if (Mask[I]=='#') Fillers--;
        Mask[I]=' ';
        I++;
      }
    if (Mask[I]==',') Mask[I]=' ';
  }

static void DoNeg(String &Mask)
  {
    int I=0;
    FindDigitToken(Mask,I);
    if (Mask[I+1]==',')
      {
        Mask[I]=' ';
        I++;
      }
    Mask[I]='-';
  }

String Form(const char* M,double Val)
  {
    String Mask=M;
    Bool Negative=(Val<0.0);
    Val=Abs(Val);
    int MaskDecPos=Mask.Index('.'); //  The position of the decimal in Mask
    int MI;  //  Mask Index:  the part of the mask currently being fooled with
    String DecStr="";
    if (MaskDecPos!=NotFound)
      {
        int Digits=0;
        for(MI=MaskDecPos+1;MI<Mask.Length();MI++)
          {
            if (Mask[MI]=='#') Mask[MI]='@';
            if (Mask[MI]=='@') Digits++;
          }
        MI=MaskDecPos+1;
        double D=(Val-floor(Val));
        Val-=D;
        double Mult=pow(10,Digits);
        D*=Mult;
        if (D+0.5>Mult)
          {
            D=0.0;
            Val+=1.0;
          }
        DecStr=Form(Mask.From(MI),D);
          //  recursive call!  This part will be skipped cuz there's no decimal in the mask
        Mask.Left(MI);  //  chop off decimal portion
      }
    int Digits=0;  // the number of digits there are available to fill
    For(MI,Mask.Length())
        if (DigitToken(Mask[MI])) Digits++;
    String IStr=DStr(Val+0.5);  //  convert the integral part to a string
    Bool NegBrackets=(Mask[0]=='<');
    Bool NegCharNeeded=((!NegBrackets)&&(Negative));
    if (NegCharNeeded) Digits--;
    if (IStr.Length()>Digits)  // then fill with *'s
      {
        For(MI,Mask.Length())
            if (DigitToken(Mask[MI])) Mask[MI]='*';
      }
    else
      {
        int Fillers=Digits-IStr.Length();
        MI=0;
        FindDigitToken(Mask,MI);
        if (Mask[MI]=='#')
          {
            DoSpaceFillers(Mask,Fillers);
            if (NegCharNeeded) DoNeg(Mask);
          }
        else
          {
            if (NegCharNeeded) DoNeg(Mask);
            DoFillers(Mask,Fillers);
          }
        int I;  //  IStr Index
        For(I,IStr.Length())
          {
            FindDigitToken(Mask,MI);
            Mask[MI]=IStr[I];
          }
      }
    Mask+=DecStr;
    if (NegBrackets && (!Negative))
      {
        Mask[0]=' ';
        Mask[Mask.Length()-1]=' ';
      }
    return (Mask);
  }

