#ifndef TFileIncluded
#define TFileIncluded

// copyright (c) 1992 by Paul Wheaton
// 1916 Brooks #205, Missoula, MT  59801
//
// voice phone:  (406)543-7543
// modem phone:  (406)543-1144 (2400N81)
//  CompuServe:  72707,207
//    Internet:  72707.207@CompuServe.com

// some documentation at end of file

/*
  Features to add:
     1)  Make it so that a person cannot write beyond the end of their block

*/

#include <File.h>

class TokenFile: public File
  {
      Word MaxTokens;
      Long FirstFreeBlock;
      void GetFreeInfo(Long Pos, Long& Size, Long& NextBlock);
        // used to traverse free list
      Long New(Long FSize);
        // returns a block number that can hold "FSize" and updates the
        // free list if needed
      void Delete(Long Pos, Long Size);
        // adds this info to the free list if its big enough
      void SeekIndexSlot(Word Token) {File::Seek(Token*8);}
      void ReadCurIndexSlot(Long& Pos, Long& Size);
      friend Bool TokenExists(const char*,Word);
      friend void ShowFreeList(const char*);
    public:
      TokenFile(const char* FileName, int BufSize=BUFSIZ);
      Long Seek(Word Token);
        /*  returns the size of your object (0 if it doesn't exist).  If
        object is found, file pointer is moved to your objects storage
        location.  You may then read your data with any binary file type
        read.  There will be nothing to stop you from reading too much */
      void WritePrep(Word Token,Long DataSize);
        /* sets up Token with a data area of just the right size.  Any
        previous data under that Token is deleted.  File pointer is left
        where writing may begin */
      void Delete(Word Token);
        // makes the space that was taken by Token's object available
      Word MaxToken(){return MaxTokens;}
      Bool TokenExists(Word Token);
      void Extract(Word Token,char* FileName);
  };

Bool TokenExists(const char* FileName, Word Token);

void SaveBootRec(TokenFile& F,const char* CName);
  // Optional...  Saves the video device boot info

/* This class inherits all of the properties of the (binary) File class.
It adds the feature of being able to store many little files into one
larger file.  Given a token ("access code", "key") value you may store and
retrieve your data pretty much like any other binary file.

Example of writing a struct of type XType:

   XType X;
   TokenFile F("DATA.BIN");
   F.WritePrep(326,sizeof(X)); // you pick your own Token number and object size
   F.WriteThing(X);

Example of reading the same struct:

   XType X;
   TokenFile F("DATA.BIN");
   if (F.Seek(326)) F.ReadThing(X);
   else FatalError("cannot find my X thing in file DATA.BIN");

*/


#endif
