#include "VecLocal.h"
#pragma hdrstop

// copyright (c) 1992 by Paul Wheaton

ByteVector::ByteVector(File& F)
  {
    Extra=DefaultVectorExtra;
    if (F.CurPos()>F.Size())
      {
        Len=0;
        Alloc=Extra;
        P = VecNew(Alloc);
      }
    else
      {
        F.ReadThing(Len);
        if (Len)
          {
            Alloc=Len+Extra;
            P =VecNew(Alloc);
            if (Len)
              {
                #ifdef Use16M
                  if (Alloc>MaxMalloc)
                    {
                      Long L=Len;
                      PtrAccess PP;
                      PP.P=P;
                      while (L)
                        {
                          Long Sp=0x10000L-PP.W.L; // space in segment above offset
                          Long RL=Min(Sp,L);  // Read Len
                          if (RL==0x10000L)
                            {
                              // in this case, the offset MUST be zero
                              F.Read(PP.P,0xFFFF);  // this fills elements 0x0000 to 0xFFFE
                              PP.W.L=0xFFFF;
                              F.Read(PP.P,1); // this fills element 0xFFFF
                            }
                          else F.Read(PP.P,size_t(RL));
                          L-=RL;
                          PP.W.H+=8;
                          PP.W.L=0;
                        }
                    }
                  else
                #endif
                F.Read(P,Len);
              }
          }
      }
  }

