#include "VecLocal.h"
#pragma hdrstop

// copyright (c) 1992 by Paul Wheaton

Bool BigVectorJump=True;

void ByteVector::MinimizeMemory()
  {
    Bool Temp=BigVectorJump;
    BigVectorJump=False;
    ReNew(Len);
    BigVectorJump=Temp;
  }

void ByteVector::ReNew(Long NewCapacity)  // replaces ANSI-C realloc
  {
    #ifdef Use16M
      if (BigVectorJump)
        {
          Byte NewSelectors=Byte((NewCapacity+0xFFFFL)/0x10000L);
          if (NewCapacity>MaxMalloc) NewCapacity=Long(NewSelectors)*0x10000L;
            // this will reduce the amount of copying needed
        }
      if (Alloc>MaxMalloc)
        {
          if (NewCapacity<=MaxMalloc)  // shrinking:  can now fit with a malloc
            {
              Byte* B=(Byte*)malloc(size_t(NewCapacity));
              if (B==NULL)
                {
                  const char* FileName="Vector.tmp";
                  DeleteFile(FileName);
                  File F(FileName);
                  F.Write(P,NewCapacity);
                  D16MemFree(P);
                  P=(Byte*)malloc(size_t(NewCapacity));
                  if (P==NULL) FatalError("memory problems in vector");
                  F.Seek(0);
                  F.Read(P,NewCapacity);
                  F.Close();
                  DeleteFile(FileName);
                }
              else
                {
                  MemCpy(B,P,NewCapacity);
                  D16MemFree(P);
                  P=B;
                }
            }
          else if (NewCapacity<=(Selectors()*0x10000L))  // HugeResize limitation
            {
              D16HugeResize(P,NewCapacity);
            }
          else // NewCapacity exceeds capacity of current selectors
            {
              Byte* T=(Byte*)D16HugeAlloc(NewCapacity);
              if (T)
                {
                  MemCpy(T,P,Len);
                  FreeMemory();
                  P=T;
                }
              else
                {
                  FatalError("vector cannot alloc mem to copy to");

                  /*
                  well, this was going to be a good idea too ( see comment
                  a few lines down).  Turns out that D16SelReserve() does a
                  D16HugeAlloc() immediately followed by D16MemFree(),
                  completely negating the reason I was going to use
                  D16SelReserve();

                  copy P to T in small chunks backwards while shrinking P and
                    expanding T.  Kill P.  Create a new P with more selectors.
                    copy T to P in small chunks backwards while shrinking T and
                    expanding P.  P will end up with more selectors and will be
                    in the proper order.

                  T=D16SelReserve(Selectors());  // T is Temp
                  if (T==NULL) FatalError("resize fail in vector");
                  const Long ChunkSize=0x10000;  // 64K:  will free a selector (and segment) at the same rate I take one
                  Long L=Len;
                  Long ChunkNum=0;
                  while(L>ChunkSize)
                    {
                      L-=ChunkSize;
                      Long NewSize=(ChunkNum+1)*ChunkSize;
                      Long Result=D16HugeResize(T,NewSize);
                      if ((Result<NewSize) FatalError("huge resize fail");
                      MemCpy(PtrInc(T,ChunkNum*ChunkSize),PtrInc(P,L-1),ChunkSize);
                      ChunkNum++;
                    }
                  Byte* T2=D16SelReserve(NewSelectors);
                  */
                }


              /* this was a great idea and took a lot of work to develop.
                 Unfortunately, after the 16M people led me this far, they
                 (the 16M people) told me that I was venturing beyond the
                 scope of their program and would no longer answer my questions
                 regarding this (which, essentially, is what they originally
                 said the D16HugeResize function did).
              PtrAccess NewP;
              NewP.P=(Byte*)D16SelReserve(int(NewSelectors));
              if (NewP.P==NULL) FatalError("out of selectors in vector");
              // copy all of the old GDT info to the new spot
              PtrAccess GDTS,GDTD; // Global Descriptor Table Source and Dest
              PtrAccess PP;
              PP.P=P;
              GDTS.W.H=8; // GDT segment location is in GDT element 8
              GDTS.W.L=PP.W.H; // GDTS now points to the actual selectors
              GDTD.W.H=8;
              GDTD.W.L=NewP.W.H;
              memcpy(GDTD.P,GDTS.P,Selectors()*8);  // I can use memcpy cuz its all in one segment
              // shift info in secondary array
              GDTS.W.H=0x50; // GDT segment location is in GDT element 8
              GDTS.W.L=PP.W.H/8; // GDTS now points to the actual selectors
              GDTD.W.H=0x50;
              GDTD.W.L=NewP.W.H/8;
              memcpy(GDTD.P,GDTS.P,Selectors());  // I can use memcpy cuz its all in one segment
              ReleaseSelectors(P,Selectors());
              P=NewP.P;
              if (!D16HugeResize(P,NewCapacity)) FatalError("huge vector out of memory");
              */
            }
        }
      else if (NewCapacity>Long(MaxMalloc))
        {
          Byte* B=VecNew(NewCapacity);
          MemCpy(B,P,Len);
          free(P);
          P=B;
        }
      else
    #endif
    P=(Byte*)realloc(P,size_t(NewCapacity));
    if (P==NULL)
        FatalError("small vector out of memory: "+Str(NewCapacity)
        #ifdef Use16M
          +' '+Str(MemAvail())
        #endif
        );
    Alloc=NewCapacity;
  }

