#include "VecLocal.h"
#pragma hdrstop

// copyright (c) 1992 by Paul Wheaton

#ifdef Use16M

  static void MemCpy(Byte* Dest,Byte* Source, Long Len)
    {
      PtrAccess D,S;
      D.P=Dest;
      S.P=Source;
      if ((D.W.L==0)&&(S.W.L==0))  // if offsets are both zero (common in 16M)
        {
          while (Len/0x10000L)
            {
              memcpy(D.P,S.P,0xFFFF);  // this copies elements 0x0000 to 0xFFFE
              D.W.L=0xFFFF;
              S.W.L=0xFFFF;
              *D.P=*S.P;               // this copies element 0xFFFF
              D.W.L=0;      // set offsets back to zero
              S.W.L=0;
              Len-=0x10000L;
              D.W.H+=8;     // bop to next selector
              S.W.H+=8;
            }
          // Len is now less than 64k
          if (Len) memcpy(D.P,S.P,size_t(Len));
        }
      else
        {
          // I could be copying from the middle of a segment to the middle of
          // another.  I could also be copying across segment boundries.
          // assume memcpy will not work across segment boundries.
          while (Len)
            {
              Long DSpace=0x10000L-D.W.L; // space in segment above offset
              Long SSpace=0x10000L-S.W.L; // space in segment above offset
              Long Sp=Min(DSpace,SSpace);  // use the smaller so we don't cross a boundry
              Long L=Min(Sp,Len);
              if (L==0x10000L)
                {
                  // in this case, both offsets MUST be zero
                  memcpy(D.P,S.P,0xFFFF);  // this copies elements 0x0000 to 0xFFFE
                  D.W.L=0xFFFF;
                  S.W.L=0xFFFF;
                  *D.P=*S.P;               // this copies element 0xFFFF
                  D.W.L=0;      // set offsets back to zero
                  S.W.L=0;
                }
              else memcpy(D.P,S.P,size_t(Len));
              Len-=L;
              D.P=PtrInc(D.P,Len);
              S.P=PtrInc(S.P,Len);
            }
        }
    }

  /*
  static void ReleaseSelectors(Byte* P, Byte OldSelectorQuan,
      Byte NewSelectorQuan=0)
    // (P,Selectors(),0) will cancel all of them
    {
      if (NewSelectorQuan>=OldSelectorQuan) return;
      int I;
      for(I=int(OldSelectorQuan-1); I>=int(NewSelectorQuan); I--)
        {
          PtrAccess PP;
          PP.P=P;
          PP.W.L=0;  // in case there's a day that the offset won't be 0
          PP.W.H+=I*8;
          D16SegCancel(PP.P);
        }
    }
  */

  static Long MemAvail()
    {
      return (D16ExtAvail()+D16LowAvail());
    }

#endif

/*

16M optimization ideas:

  On the realloc stuff, if sizing down, check to see if a few selectors
  could be freed.

  Maintain a linked list of vectors that use D16HugeAlloc.  If low on
  selectors:
     a) see about temporarily suspending a few selectors
     b) try doing a "garbage collection" with the GDT
     c) Use MinMem func on all vectors in linked list

  Make a function for the window stuff (a big memory hog, especially in
  hi-res) to force all heap data to the disk.

*/


