// SCRNBOX.HPP : drawing menu boxes on the screen
// by Bruce Eckel. (c) The C Gazette

class screen_box {
    unsigned * oldscreen; // place to store old screen
    unsigned x, y;  // upper left corner coordinates
    unsigned height, width;
    void * boxrep;
    // for use with graphics.  A void * is used so the particular
    // representation is unimportant in the general case (i.e.
    // so the graphics header doesn't have to be included, which
    // would destroy the generality).  This makes for a messier
    // implementation but a cleaner interface.
public:
    // Draw a menu box, saving the old screen beneath it:
    screen_box(unsigned ypos, unsigned xpos,
                       unsigned bheight, unsigned bwidth);
    // Delete the menu box and restore the old screen:
    ~screen_box();
    // Move to the beginning of a line in the box:
    void move(int line);
    // Put a character in the box:
    void put_c(char);
    // Put an emphasized character in the box:
    void emphasize(char);
};