' Box3D.Bas - Clone of BOX from GENERAL.BAS, adapted
'             to use Tony Goodman's suggested 3D effect. 
'             Portions Copyright 1987-1990 Microsoft Corp.

' $INCLUDE: 'MOUSE.BI'
' $INCLUDE: 'BOX3D.BI'

CONST MINCOL = 1, MAXCOL = 80, MINROW = 1, MAXROW = 80

DEFINT A-Z

SUB Box3D (row1, col1, row2, col2, fg, bg, high, border$, fill) STATIC

'=======================================================================
'  Use default border if an illegal border$ is passed
'=======================================================================

  IF border$ <> "DOUBLE" THEN
    IF border$ = "SINGLE" OR LEN(border$) < 9 THEN
      t$ = "Ŀ "
    ELSE
      t$ = border$
    END IF
  ELSE
    t$ = "ͻ ͼ"
  END IF

' =======================================================================
' Check coordinates for validity, then draw box
' =======================================================================

  IF col1 <= (col2 - 2) AND row1 <= (row2 - 2) _
   AND col1 >= MINCOL AND row1 >= MINROW _
   AND col2 <= MAXCOL AND row2 <= MAXROW THEN
    MouseHide
    BoxWidth = col2 - col1 + 1
    BoxHeight = row2 - row1 + 1
    LOCATE row1, col1
    COLOR fg, bg
    PRINT LEFT$(t$, 1); STRING$(BoxWidth - 2, MID$(t$, 2, 1));
    COLOR high, bg
    PRINT MID$(t$, 3, 1);
    COLOR fg, bg
    LOCATE row2, col1
    PRINT MID$(t$, 7, 1); 
    COLOR high, bg
    PRINT STRING$(BoxWidth - 2, MID$(t$, 8, 1)); MID$(t$, 9, 1);

    FOR a = row1 + 1 TO row1 + BoxHeight - 2
       LOCATE a, col1
       COLOR fg, bg
       PRINT MID$(t$, 4, 1);

       IF fill THEN
         PRINT STRING$(BoxWidth - 2, MID$(t$, 5, 1));
       ELSE
        LOCATE a, col1 + BoxWidth - 1
       END IF

       COLOR high, bg
       PRINT MID$(t$, 6, 1);
    NEXT a
    LOCATE row1 + 1, col1 + 1
    MouseShow
  END IF

END SUB

