Version 1.00
BEGIN Form frmHelpUtils
	AutoRedraw   = 0
	BackColor    = QBColor(7)
	BorderStyle  = 1
	Caption      = "Search"
	ControlBox   = -1
	Enabled      = -1
	ForeColor    = QBColor(0)
	Height       = Char(18)
	Left         = Char(14)
	MaxButton    = 0
	MinButton    = 0
	MousePointer = 0
	Tag          = ""
	Top          = Char(3)
	Visible      = -1
	Width        = Char(55)
	WindowState  = 0
	BEGIN TextBox txtCopyArea
		BackColor    = QBColor(7)
		BorderStyle  = 1
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(14)
		Left         = Char(1)
		MousePointer = 0
		MultiLine    = -1
		ScrollBars   = 3
		TabIndex     = 0
		TabStop      = -1
		Tag          = ""
		Text         = ""
		Top          = Char(2)
		Visible      = 0
		Width        = Char(45)
	END
	BEGIN CommandButton cmdOK
		BackColor    = QBColor(7)
		Cancel       = 0
		Caption      = "OK"
		Default      = -1
		DragMode     = 0
		Enabled      = -1
		Height       = Char(3)
		Left         = Char(40)
		MousePointer = 0
		TabIndex     = 3
		TabStop      = -1
		Tag          = ""
		Top          = Char(2)
		Visible      = -1
		Width        = Char(12)
	END
	BEGIN CommandButton cmdCancel
		BackColor    = QBColor(7)
		Cancel       = -1
		Caption      = "Cancel"
		Default      = 0
		DragMode     = 0
		Enabled      = -1
		Height       = Char(3)
		Left         = Char(40)
		MousePointer = 0
		TabIndex     = 4
		TabStop      = -1
		Tag          = ""
		Top          = Char(5)
		Visible      = -1
		Width        = Char(12)
	END
	BEGIN Label lblSelectText
		Alignment    = 0
		AutoSize     = 0
		BackColor    = QBColor(7)
		BorderStyle  = 0
		Caption      = "Select text to copy to the Clipboard:"
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(1)
		Left         = Char(1)
		MousePointer = 0
		TabIndex     = 5
		Tag          = ""
		Top          = Char(1)
		Visible      = 0
		Width        = Char(38)
	END
	BEGIN ListBox lstSearch
		BackColor    = QBColor(7)
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(14)
		Left         = Char(1)
		MousePointer = 0
		Sorted       = -1
		TabIndex     = 1
		TabStop      = -1
		Tag          = ""
		Top          = Char(2)
		Visible      = -1
		Width        = Char(37)
	END
	BEGIN ListBox lstHistory
		BackColor    = QBColor(7)
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(14)
		Left         = Char(1)
		MousePointer = 0
		Sorted       = 0
		TabIndex     = 2
		TabStop      = -1
		Tag          = ""
		Top          = Char(2)
		Visible      = 0
		Width        = Char(37)
	END
	BEGIN Label lblSelectTopic
		Alignment    = 0
		AutoSize     = 0
		BackColor    = QBColor(7)
		BorderStyle  = 0
		Caption      = "Select topic to display:"
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(1)
		Left         = Char(1)
		MousePointer = 0
		TabIndex     = 6
		Tag          = ""
		Top          = Char(1)
		Visible      = -1
		Width        = Char(26)
	END
END
' ------------------------------------------------------------------------
' Visual Basic for MS-DOS Help Toolkit
'
' Form for Search, History, and Change dialogs.
'
' The Help Toolkit (HELP.BAS, HELPF.FRM, and HELPUTIL.FRM)
' makes it easy to add a hypertext Help system to your
' applications.
'
' To use the Help Toolkit in your programs, include
' HELP.BAS, HELPF.FRM, and HELPUTIL.FRM in your program or
' use the supplied library (HELP.LIB, HELPA.LIB - AltMath
' version) and Quick library (HELP.QLB) and call the
' appropriate routines to load and display your help topics.
' Forms and code modules that call Help routines
' must include HELP.BI ('$INCLUDE: 'HELP.BI').
'
' Refer to the module level comments in HELP.BAS for
' more information on using the Help Toolkit.
'
' Copyright (C) 1982-1992 Microsoft Corporation
'
' You have a royalty-free right to use, modify, reproduce
' and distribute the sample applications and toolkits provided with
' Visual Basic for MS-DOS (and/or any modified version)
' in any way you find useful, provided that you agree that
' Microsoft has no warranty, obligations or liability for
' any of the sample applications or toolkits.
' ------------------------------------------------------------------------

' Include file containing procedure declarations.
'$INCLUDE: 'HELP.BI'

' Variables common to HELP.BAS, HELPF.FRM, and HELPUTIL.FRM.
COMMON SHARED /HelpLib/ DialogBackcolor AS INTEGER ' Background color for Help dialog boxes (Search, Copy, History)
COMMON SHARED /HelpLib/ DialogForecolor AS INTEGER ' Foreground color for Help dialog boxes (Search, Copy, History)

CONST FALSE = 0
CONST TRUE = NOT FALSE

' Click event for Cancel command button.
' Hides the form and sets the form's tag property to null.
'
SUB cmdCancel_Click ()
    tag = ""
    HIDE
END SUB

' Click event procedure for the OK command button.
' Changes the form's tag property to
' a value depending on the type of dialog
' being used (e.g. Search, History, or Copy).
'
SUB cmdOK_Click ()
    SELECT CASE Caption
        CASE "Search"
            tag = lstSearch.Text
        CASE "History"
            tag = lstHistory.Text
        CASE "Copy"
            ' Check if any text is selected.  If not,
            ' assume the person wants to copy it all.
            IF txtCopyArea.SelLength = 0 THEN
                txtCopyArea.SelStart = 0
                txtCopyArea.SelLength = LEN(txtCopyArea.Text)
            END IF
            clipboard.SETTEXT txtCopyArea.SelText
    END SELECT
    HIDE
END SUB

' Load event procedure for the form.
' Centers the dialog.
'
SUB Form_Load ()
    Left = (screen.Width - Width) \ 2
    Top = (screen.Height - Height) \ 2

    ' Set all control and form colors using the
    ' colors set with HelpSetOptions.
    Backcolor = DialogBackcolor
    txtCopyArea.Backcolor = DialogBackcolor
    Backcolor = DialogBackcolor
    cmdOK.Backcolor = DialogBackcolor
    cmdCancel.Backcolor = DialogBackcolor
    lblSelectText.Backcolor = DialogBackcolor
    lstSearch.Backcolor = DialogBackcolor
    lstHistory.Backcolor = DialogBackcolor
    lblSelectTopic.Backcolor = DialogBackcolor

    Forecolor = DialogForecolor
    txtCopyArea.Forecolor = DialogForecolor
    lblSelectText.Forecolor = DialogForecolor
    lstSearch.Forecolor = DialogForecolor
    lstHistory.Forecolor = DialogForecolor
    lblSelectTopic.Forecolor = DialogForecolor

END SUB

' Double Click event procedure for the History listbox.
' Invokes click event procedure for the OK command button.
'
SUB lstHistory_dblClick ()
    CALL cmdOK_Click
END SUB

' Double Click event procedure for the Search listbox.
' Invokes click event procedure for the OK command button.
'
SUB lstSearch_dblClick ()
    CALL cmdOK_Click
END SUB

