;SCRNSR.ASM -- Screen save & restore routines for use with
;              Microsoft QB 4.x, PDS 7.x & VB/DOS 1.x.

.Model Medium, Basic

.Data
MonSeg    DW   ?
MonOfs    DW   ?
Wide      DW   ?

.Code
Proc ScrnSave Uses DS ES DI SI, Array:Word, ULRow:Word, ULCol:Word, LRRow:Word, LRCol:Word

     Cmp  MonSeg, 0           ;See if MonSeg has a value.
     Jnz  Mono                ;If so, skip initialization.
     Mov  MonSeg, 0B000h      ;Assume monochrome.
     Xor  AX, AX
     Mov  ES, AX              ;Point ES at low memory.
     Mov  AL, ES:[463h]       ;Check byte at &H463.
     Cmp  AL, 0B4h            ;If it's &HB4, we've got a
     Je   Mono                ;mono adapter.
     Add  MonSeg, 800h        ;Else, add 800h to MonSeg
                              ;for color video.
Mono:
     Mov  AH, 0Fh             ;Get current video mode.
     Push BP                  ;Some old BIOS's trash BP
     Int  10h                 ;during an Int 10h.
     Pop  BP                  ;Returns columns in AH.
     Mov  AL, AH              ;Put # columns in AL and
     Cbw                      ;clear AH.
     Shl  AX, 1               ;Times 2 for attributes.
     Mov  Wide, AX            ;Save it in Wide and in
     Mov  BX, AX              ;BX for multiply below.

     Mov  SI, ULRow           ;Put address of ULRow in SI.
     Mov  AL, [SI]            ;Put ULRow value into AL.
     Dec  AL                  ;Adjust 1-25 to 0-24.
     Cbw                      ;Multiply by width to get
     Mul  BX                  ;address of first row in
                              ;video memory.

     Mov  SI, ULCol           ;Put address of ULCol in SI.
     Mov  BX, [SI]            ;Put ULCol value into BX.
     Dec  BX                  ;Adjust as above.
     Shl  BX, 1               ;Times 2 for attributes.
     Add  AX, BX              ;Add column offset to AX to
     Mov  MonOfs, AX          ;get start address of screen
                              ;memory to be saved.

     Mov  SI, LRRow           ;Put address of LRRow in SI.
     Mov  BH, [SI]            ;Put LRRow value into BH.
     Mov  SI, ULRow           ;Get address for ULRow.
     Sub  BH, [SI]            ;Subtract to get total rows.
     Inc  BH                  ;Add 1, because
                              ;Rows = (LRRow - ULRow) + 1

     Xor  CH, CH              ;Clear CH.
     Mov  SI, LRCol           ;Put address of LRCol in SI.
     Mov  CL, [SI]            ;Put LRCol value into CL.
     Mov  SI, ULCol           ;Get address for ULCol.
     Sub  CL, [SI]            ;Subtract to get total cols.
     Inc  CL                  ;Add 1 because
                              ;Cols = (LRCol - ULCol) + 1
    
     Xor  AH, AH              ;Set AX = Rows.
     Mov  AL, BH              ;Multiply by columns so that
     Mul  CL                  ;AX contains elements needed.                             
     Mov  SI, Array           ;Point SI at array descriptor.
     Mov  DX, [SI+0Eh]        ;Number of elements in DX.
     Cmp  AX, DX              ;Compare elements needed with
     Ja   Done                ;those available -- exit if
                              ;array is too small.

     Mov  DI, [SI]            ;Get address of first element.
     Mov  ES, [SI+02h]        ;Array segment in ES.
     Mov  DX, MonSeg
     Mov  DS, DX              ;Point DS to screen memory.
     Mov  BL, CL              ;Save column counter in BL.
     Cld                      ;Moves will be forward.

NextRow:
     Mov  CL, BL              ;Retrieve column counter.
     Mov  SI, SS:[MonOfs]     ;Point SI to current row.
     Rep  Movsw               ;Move row of chars and attribs.
     Mov  AX, SS:[Wide]       ;Get the screen width.
     Add  SS:[MonOfs], AX     ;Add to MonOfs to point to
     Dec  BH                  ;next row.
     Jnz  NextRow             ;Loop until BH = 0.

Done:
     Ret                      ;Return to BASIC.

ScrnSave Endp
Proc ScrnRest Uses DS ES DI SI, Array:Word, ULRow:Word, ULCol:Word, LRRow:Word, LRCol:Word

     Cmp  MonSeg, 0           ;See if MonSeg has a value.
     Jnz  Mono2               ;If so, skip initialization.
     Mov  MonSeg, 0B000h      ;Assume monochrome.
     Xor  AX, AX
     Mov  ES, AX              ;Point ES at low memory.
     Mov  AL, ES:[463h]       ;Check byte at &H463.
     Cmp  AL, 0B4h            ;If it's &HB4, we've got a
     Je   Mono2               ;mono adapter.
     Add  MonSeg, 800h        ;Else, add 800h to MonSeg
                              ;for color video.
Mono2:
     Mov  AH, 0Fh             ;Get current video mode.
     Push BP                  ;Some old BIOS's trash BP
     Int  10h                 ;during an Int 10h.
     Pop  BP                  ;Returns columns in AH.
     Mov  AL, AH              ;Put # columns in AL and
     Cbw                      ;clear AH.
     Shl  AX, 1               ;Times 2 for attributes.
     Mov  Wide, AX            ;Save it in Wide and in
     Mov  BX, AX              ;BX for multiply below.

     Mov  SI, ULRow           ;Put address of ULRow in SI.
     Mov  AL, [SI]            ;Put ULRow value into AL.
     Dec  AL                  ;Adjust 1-25 to 0-24.
     Cbw                      ;Multiply by width to get
     Mul  BX                  ;address of first row in
                              ;video memory.

     Mov  SI, ULCol           ;Put address of ULCol in SI.
     Mov  BX, [SI]            ;Put ULCol value into BX.
     Dec  BX                  ;Adjust as above.
     Shl  BX, 1               ;Times 2 for attributes.
     Add  AX, BX              ;Add column offset to AX to
     Mov  MonOfs, AX          ;get start address of screen
                              ;memory to be saved.

     Mov  SI, LRRow           ;Put address of LRRow in SI.
     Mov  BH, [SI]            ;Put LRRow value into BH.
     Mov  SI, ULRow           ;Get address for ULRow.
     Sub  BH, [SI]            ;Subtract to get total rows.
     Inc  BH                  ;Add 1, because
                              ;Rows = (LRRow - ULRow) + 1

     Xor  CH, CH              ;Clear CH.
     Mov  SI, LRCol           ;Put address of LRCol in SI.
     Mov  CL, [SI]            ;Put LRCol value into CL.
     Mov  SI, ULCol           ;Get address for ULCol.
     Sub  CL, [SI]            ;Subtract to get total cols.
     Inc  CL                  ;Add 1 because
                              ;Cols = (LRCol - ULCol) + 1
    
     Xor  AH, AH              ;Set AX = Rows.
     Mov  AL, BH              ;Multiply by columns so that
     Mul  CL                  ;AX contains elements needed.
     Mov  DI, Array           ;Point DI at array descriptor.
     Mov  DX, [DI+0Eh]        ;Number of elements in DX.
     Cmp  AX, DX              ;Compare elements needed with
     Ja   Done2               ;those available -- exit if
                              ;array is too small.

     Mov  DX, MonSeg
     Mov  ES, DX              ;Point ES to screen memory.
     Mov  SI, [DI]            ;Get address of first element.
     Mov  DS, [DI+02h]        ;Array segment in DS.
     Mov  BL, CL              ;Save column counter in BL.
     Cld                      ;Moves will be forward.

NextRow2:
     Mov  CL, BL              ;Retrieve column counter.
     Mov  DI, SS:[MonOfs]     ;Point DI to current row.
     Rep  Movsw               ;Move row of chars and attribs.
     Mov  AX, SS:[Wide]       ;Get the screen width.
     Add  SS:[MonOfs], AX     ;Add to MonOfs to point to
     Dec  BH                  ;next row.
     Jnz  NextRow2            ;Loop until BH = 0.

Done2:
     Ret                      ;Return to BASIC.

ScrnRest Endp
End

