	page ,132
	title	EGA/VGA Blink On/Off by Jim Mack
	subttl	Copyright 1992 Editing Services Co.

comment	|
	 A QB/PDS/VBDos callable SUB which controls EGA/VGA blinking.  
	 
	 Foreground colors from 16..31 are usually the blinking versions of
	 the colors from 0..15.  But when blinking is turned off (the norm 
	 for VB-DOS when the Desktop is shown), they instead cause the BG 
	 color to become intense (higher luminance).

	 This affects the entire screen at once, not individual items.

	 This routine will usually have no effect on a standard mono system.

	 To use the routine, LINK it to your compiled programs, or place it
	 into your standard LIB.  You can place this into a .QLB for use in
	 the development environment as well.

	 To use the routine, DECLARE it like this:

	 	DECLARE SUB Blinking (ByVal BlinkOn%)

	 Then to turn blinking on:

	 	Blinking True	'any non-zero value

	 To turn blinking off:

	 	Blinking False	'zero
	|

	.model medium, basic
	.code

Blinking	PROC BlinkOn

	xor	ax, ax		; make a zero for comparison
	cmp	ax, BlinkOn	; set carry if blinking desired
	sbb	bx, bx		; becomes -1 for Blink, 0 for none
	neg	bx		; BL = 1 or 0
	mov	ax, 1003H	; palette operations, Blink/Intense BG
	INT	10H		; invoke BIOS video service
	ret

Blinking	ENDP
	
	END
