//---------------------------------------------------------------------------
// GRIDAPI.H
//---------------------------------------------------------------------------

#ifdef __cplusplus 
extern "C" { 
#endif 
#ifndef GRID_CONSTANTS
#define GRID_CONSTANTS

#define IPROP_GRIGLIA_ROWS              0x0017                
#define IPROP_GRIGLIA_COLS              0x0018                
#define IPROP_GRIGLIA_FIXEDROWS      	0x0019
#define IPROP_GRIGLIA_FIXEDCOLS      	0x001A
#define IPROP_GRIGLIA_ROW            	0x001B
#define IPROP_GRIGLIA_COL            	0x001C
#define IPROP_GRIGLIA_ROWHEIGHT      	0x001D
#define IPROP_GRIGLIA_COLWIDTH       	0x001E
#define IPROP_GRIGLIA_TOPROW         	0x001F
#define IPROP_GRIGLIA_LEFTCOL        	0x0020
#define IPROP_GRIGLIA_CURSORROW      	0x0021
#define IPROP_GRIGLIA_CURSORCOL      	0x0022
#define IPROP_GRIGLIA_TEXT              0x0023                
#define IPROP_GRIGLIA_CLIP              0x0024                
#define IPROP_GRIGLIA_SELSTARTROW       0x0025        
#define IPROP_GRIGLIA_SELENDROW         0x0026        
#define IPROP_GRIGLIA_SELSTARTCOL       0x0027        
#define IPROP_GRIGLIA_SELENDCOL         0x0028        
#define IPROP_GRIGLIA_ENABLECOL         0x0029        
#define IPROP_GRIGLIA_ENABLEROW         0x002A        
#define IPROP_GRIGLIA_ACCESSCOL 	0x002B
#define IPROP_GRIGLIA_ACCESSROW 	0x002C
#define IPROP_GRIGLIA_ENABLEEDIT	0x002D
#define IPROP_GRIGLIA_ENABLESCROLLBARS	0x002E

#define LEFT_JUST     0
#define CENTER_JUST   1
#define RIGHT_JUST    2

typedef struct tagFind {

	WORD	wCol;
	LPSTR   lpText;

} FINDTEXT;
typedef FINDTEXT FAR * LPFINDTEXT;

#define 	PASSWORD	(BYTE)0x7F
#define         BOLD            0x0001
#define         ITALIC          0x0002
#define         UNDERLINE       0x0004
#define         DISABLE         0x0008

#define         DISABLE_FLAG    0x0000
#define         ENABLE_FLAG     0x0001
#define         NOTACCESS_FLAG  0x0002
#define         ACCESS_FLAG     0x0004
#define         NOWRAP_FLAG     0x0000
#define         WRAP_FLAG       0x0010
#define         LEFT_FLAG       0x0020
#define         RIGHT_FLAG      0x0040
#define         CENTER_FLAG     0x0080

#define         J_LEFT          0x0020
#define         J_CENTER        0x0040
#define         J_RIGHT         0x0080

typedef struct {

    BYTE        byPassword;
    BYTE        bySize;
    COLORREF    rgbFColor;
    COLORREF    rgbBColor;
    UINT        uStatus;
    LPSTR       lpFaceName;

} EXT_INPUT;
typedef EXT_INPUT FAR * LPEXT_INPUT;

#endif

// api.c
#ifdef ARCH_GRIGLIA	// Grid with Arch. Text
VOID FAR PASCAL _export
                                RepaintGriglia          (HWND);
VOID FAR PASCAL _export
                                RepaintGrigliaBlock     (HWND, UINT, UINT,
                                                               UINT, UINT);
BOOL FAR PASCAL _export
				GetGrigliaProperty 	(HWND, USHORT, LPVOID);
BOOL FAR PASCAL _export
				SetGrigliaProperty 	(HWND, USHORT, LONG);
BOOL FAR PASCAL _export
                                PutText                 (HWND, WORD, WORD, LPSTR);        
LPSTR FAR PASCAL _export
                                GetText                 (HWND, WORD, WORD);
BOOL FAR PASCAL _export
				InsertLines    		(HWND, WORD, WORD);
BOOL FAR PASCAL _export
				DeleteLines    		(HWND, WORD, WORD);
BOOL FAR PASCAL _export
                                FindLine                (HWND, LPFINDTEXT);
void FAR PASCAL _export
                                EraseGrid               (HWND);
void FAR PASCAL _export         
                                SetColSize              (HWND, UINT, UINT);
BOOL FAR PASCAL _export
                                SortLine                (HWND, LPFINDTEXT);
void FAR PASCAL _export
                                InsertCells             (HWND, WORD, WORD, WORD);
void FAR PASCAL _export
                                InsertLineBreak         (HWND, WORD, WORD);
void FAR PASCAL _export
                                DeleteCells             (HWND, WORD, WORD, WORD);
void FAR PASCAL _export
                                DeleteLineBreak         (HWND, WORD, WORD);
void FAR PASCAL _export
                                MoveWordRight           (HWND, WORD, WORD);
void FAR PASCAL _export
                                MoveWordLeft            (HWND, WORD, WORD);
void FAR PASCAL _export
                                ShiftWordRight          (HWND, WORD, WORD);
void FAR PASCAL _export
                                ShiftWordLeft           (HWND, WORD, WORD);

UINT FAR PASCAL _export         GetBlockSize            (HWND, WORD, WORD,      
                                                               WORD, WORD);  
void FAR PASCAL _export         CJust                   (HWND, WORD, WORD,
                                                               WORD, WORD);  
void FAR PASCAL _export         LJust                   (HWND, WORD, WORD,
                                                               WORD, WORD);  
void FAR PASCAL _export         RJust                   (HWND, WORD, WORD,
                                                               WORD, WORD);  
BOOL FAR PASCAL _export         IsBlockEmpty            (HWND, WORD, WORD,
                                                               WORD, WORD);  
BOOL FAR PASCAL _export
                                PutText_Ext             (HWND, WORD, WORD,
                                                         LPEXT_INPUT, LPSTR);
LPSTR FAR PASCAL _export
                                GetText_Ext             (HWND, WORD, WORD,
                                                         LPEXT_INPUT);
void FAR PASCAL _export         AdjustColumnSizes       (HWND);

BOOL FAR PASCAL _export         SetColStatus            (HWND, UINT, WORD);

BOOL FAR PASCAL _export         SetRowStatus            (HWND, UINT, WORD);

WORD FAR PASCAL _export         GetColStatus            (HWND, UINT);

WORD FAR PASCAL _export         GetRowStatus            (HWND, UINT);

BOOL FAR PASCAL _export         GetTextLine             (HWND, WORD, WORD, WORD,
                                                         LPSTR, int);

#else

VOID FAR PASCAL _export
                                dRepaintGriglia          (HWND);
VOID FAR PASCAL _export
                                dRepaintGrigliaBlock     (HWND, UINT, UINT,
                                                               UINT, UINT);
BOOL FAR PASCAL _export
                                dGetGrigliaProperty      (HWND, USHORT, LPVOID);
BOOL FAR PASCAL _export
                                dSetGrigliaProperty      (HWND, USHORT, LONG);
BOOL FAR PASCAL _export
                                dPutText                 (HWND, WORD, WORD, LPSTR);
LPSTR FAR PASCAL _export
                                dGetText                 (HWND, WORD, WORD);
BOOL FAR PASCAL _export
                                dInsertLines             (HWND, WORD, WORD);
BOOL FAR PASCAL _export
                                dDeleteLines             (HWND, WORD, WORD);
BOOL FAR PASCAL _export
                                dFindLine                (HWND, LPFINDTEXT);
void FAR PASCAL _export
                                dEraseGrid               (HWND);
void FAR PASCAL _export         
                                dSetColSize              (HWND, UINT, UINT);
BOOL FAR PASCAL _export
                                dSortLine                (HWND, LPFINDTEXT);
void FAR PASCAL _export
                                dInsertCells             (HWND, WORD, WORD, WORD);
void FAR PASCAL _export
                                dInsertLineBreak         (HWND, WORD, WORD);
void FAR PASCAL _export
                                dDeleteCells             (HWND, WORD, WORD, WORD);
void FAR PASCAL _export
                                dDeleteLineBreak         (HWND, WORD, WORD);
void FAR PASCAL _export
                                dMoveWordRight           (HWND, WORD, WORD);
void FAR PASCAL _export
                                dMoveWordLeft            (HWND, WORD, WORD);
void FAR PASCAL _export
                                dShiftWordRight          (HWND, WORD, WORD);
void FAR PASCAL _export
                                dShiftWordLeft           (HWND, WORD, WORD);

UINT FAR PASCAL _export         dGetBlockSize            (HWND, WORD, WORD,
                                                               WORD, WORD);  
void FAR PASCAL _export         dCJust                   (HWND, WORD, WORD,
                                                               WORD, WORD);  
void FAR PASCAL _export         dLJust                   (HWND, WORD, WORD,
                                                               WORD, WORD);  
void FAR PASCAL _export         dRJust                   (HWND, WORD, WORD,
                                                               WORD, WORD);  
BOOL FAR PASCAL _export         dIsBlockEmpty            (HWND, WORD, WORD,
                                                               WORD, WORD);  
BOOL FAR PASCAL _export
                                dPutText_Ext             (HWND, WORD, WORD,
                                                         LPEXT_INPUT, LPSTR);
LPSTR FAR PASCAL _export
                                dGetText_Ext             (HWND, WORD, WORD,
                                                         LPEXT_INPUT);
void FAR PASCAL _export         dAdjustColumnSizes       (HWND);

BOOL FAR PASCAL _export         dSetColStatus            (HWND, UINT, WORD);

BOOL FAR PASCAL _export         dSetRowStatus            (HWND, UINT, WORD);

WORD FAR PASCAL _export         dGetColStatus            (HWND, UINT);

WORD FAR PASCAL _export         dGetRowStatus            (HWND, UINT);

//----------------------- define CALLBACK -----------------------------------

#define ICALLBACK_GETCELLTEXT		0x0000
#define ICALLBACK_PUTCELLTEXT		0x0001
#define ICALLBACK_GETCELLTEXT_EXT	0x0002
#define ICALLBACK_PUTCELLTEXT_EXT	0x0003
#define ICALLBACK_INSERTCELLSTEXT	0x0004
#define ICALLBACK_DELETECELLSTEXT	0x0005
#define ICALLBACK_SORTTEXT		0x0006
#define ICALLBACK_SWITCHLINES		0x0007
#define ICALLBACK_COMPARELINES		0x0008
#define ICALLBACK_CLEARTEXT		0x0009
#define ICALLBACK_FINDTEXT		0x000A
#define ICALLBACK_INSERTLINESTEXT	0x000B
#define ICALLBACK_DELETELINESTEXT	0x000C


BOOL FAR PASCAL _export 	SetCallBackEntry (HWND, WORD, FARPROC);

//---------------------------------------------------------------------------

#endif // ARCH_GRIGLIA
#ifdef __cplusplus 
} 
#endif 
